---
name: Feature Request (Mod)
about: Suggest a new feature or improvement for this mod.
title: [FEATURE] - Concise description of the feature
labels: feature request, gameplay, UI
assignees: ''
---
**Mod Name:**

Specify which mod this feature request is for.

**Describe the Feature:**

Provide a clear and concise description of the new feature or improvement you're requesting. Explain what it does and how it should work.

**Motivation:**

Explain why this feature is needed and what problem it solves. What are the benefits of implementing this feature? Provide context and use cases.  How would this improve the game experience for players?

**Proposed Implementation:**

If you have a specific idea for how this feature could be implemented, describe it here.  Include any relevant code snippets, mockups, or diagrams.  Be as detailed as possible about the technical aspects.

**Alternatives Considered (Optional):**

Have you considered any alternative solutions? If so, explain why you think your proposed solution is the best approach.

**Dependencies:**

Does this feature depend on any other mods or game versions?

**Additional Context:**

Add any other relevant information or context that might be helpful for the developers. This could include links to other resources, screenshots, or videos.

**Examples (Optional):**

Provide specific examples of how the feature would be used in the game. This helps developers understand the use case and prioritize accordingly.

**Checklist :**



- [ ] I have searched the existing issues and have not found a similar request.
- [ ] I am willing to contribute to the implementation of this feature (optional).
- [ ] I have provided enough information for the developers to understand and evaluate my request.
